require "net/http"
require "uri"
require_relative "../primo_central_counter"

class PrimoCentralCounter::ConnectionChecker
  def self.call(primo_base_url, options = {})
    logger = options[:logger]

    log_info(logger, "Checking connection to Primo Central")
    url = URI.parse("#{primo_base_url}/PrimoWebServices/services/searcher")
    response = Net::HTTP.get_response(url)

    if response.body[/IP address rejected/]
      false
    else
      true
    end
  rescue Errno::ECONNREFUSED
    false
  end

  private

  def self.log_info(logger, message)
    logger.info(message) if logger
  end
end
