require "net/http"
require "rexml/document"
require "uri"
require_relative "../primo_central_counter"

class PrimoCentralCounter::SoapDiscoverer
  def self.call(primo_base_url, options = {})
    logger = options[:logger]

    log_info(logger, "Retriving WSDL")
    wsdl_url = URI.parse("#{primo_base_url}/PrimoWebServices/services/searcher?wsdl")
    response = Net::HTTP.get_response(wsdl_url)
    doc = REXML::Document.new response.body
    doc.elements["//wsdl:service//wsdlsoap:address"].attributes["location"]
  end

  private

  def self.log_info(logger, message)
    logger.info(message) if logger
  end
end
